#version 330

in vec2 fs_texcoord;

uniform sampler2D fbo_texture;
uniform vec3 window;

out vec4 fragColor;

void main() {
	float dx = 1.0 / float(window.x);
	float dy = 1.0 / float(window.y);

	float s00 = texture(fbo_texture, fs_texcoord + vec2(-dx,  dy));
	float s10 = texture(fbo_texture, fs_texcoord + vec2(-dx, 0.0));
	float s20 = texture(fbo_texture, fs_texcoord + vec2(-dx, -dy));
	float s01 = texture(fbo_texture, fs_texcoord + vec2(0.0,  dy));
	float s21 = texture(fbo_texture, fs_texcoord + vec2(0.0, -dy));
	float s02 = texture(fbo_texture, fs_texcoord + vec2( dx,  dy));
	float s12 = texture(fbo_texture, fs_texcoord + vec2( dx, 0.0));
	float s22 = texture(fbo_texture, fs_texcoord + vec2( dx, -dy));

	float sx = -s00 - 2 * s10 - s20 + s02 + 2 * s12 + s22;
	float sy = -s00 - 2 * s01 - s02 + s20 + 2 * s21 + s22;

	float sx2 = +s00 + 2 * s10 + s20 - s02 - 2 * s12 - s22;
	float sy2 = +s00 + 2 * s01 + s02 - s20 - 2 * s21 - s22;

	float dist = sqrt(sx * sx + sy * sy);
	float dist2 = sqrt(sx2 * sx2 + sy2 * sy2);

	float thresh = 0.9;
	if(dist > thresh || dist2 > thresh) {
		fragColor = texture(fbo_texture, fs_texcoord)*0.8;
	} else {
		fragColor = texture(fbo_texture, fs_texcoord);
	}
	//fragColor = vec4(clamp(dist, 0.0, 1.0));
}
