#version 430 core

layout(points) in;
layout(triangle_strip, max_vertices = 4) out;

uniform mat4 view;
uniform mat4 projection;

in float vTtl[1];

out vec2 gTexCoord;
out float gTtl;

void main()
{
    vec3 camp = vec3(0,150,-50);
    
    // Emit the quad:
    vec3 p = (view*gl_in[0].gl_Position).xyz;

    vec3 up = vec3(0.0, 1.0, 0.0);
    vec3 right = cross(p, up);

    float s = 0.8;

    gl_Position = projection * vec4(p+vec3(-s,-s,0), 1.0);
    gTexCoord = vec2(0.0, 0.0);
    gTtl = vTtl[0];
    EmitVertex();

    gl_Position = projection * vec4(p+vec3(-s,s,0), 1.0);
    gTexCoord = vec2(0.0, 1.0);
    gTtl = vTtl[0];
    EmitVertex();

    gl_Position = projection * vec4(p+vec3(s,-s,0), 1.0);
    gTexCoord = vec2(1.0, 0.0);
    gTtl = vTtl[0];
    EmitVertex();

    gl_Position = projection * vec4(p+vec3(s,s,0), 1.0);
    gTexCoord = vec2(1.0, 1.0);
    gTtl = vTtl[0];
    EmitVertex();

    EndPrimitive();
}